<?php
	// 
	defined('_JEXEC') or die();
	
	// 
	require_once(JPATH_SITE.'/components/com_jshopping/addons/addon_core.php');	
	
	
	// 
	// 
	class AddonPMRucode extends AddonCore
	{
		// 
		// 
		protected $addon_alias = 'pmrucode';
		
		
		// 
		// 
		private static $instance;
		
		
		// 
		// 
		public function __construct()
		{
			// Прячем конструктор
		}
		
		
		// 
		// 
		private function __clone()
		{
			// Отключаем клонирование
		}
		
		
		// 
		// 
		private function __wakeup()
		{
			// Отключаем десериализацию
		}
		
		
		// 
		// 
		public static function getInstance(): AddonPMRucode
		{
			// 
			// 
			if (!self::$instance)
			{
				// 
				// 
				self::$instance = new self();
			}
			// 
			// 
			self::$instance->params = self::$instance->getAddonParams();
			// 
			// 
			return self::$instance;
		}
		
		
		// 
		// 
		public function getAddonParams()
		{
			// 
			// 
			if (!$this->addon_params)
			{
				// 
				// 
				$addon_params = parent::getAddonParams();
				// 
				// 
				$registry = new JRegistry();
				// 
				// 
				$registry->loadArray($addon_params);
				// 
				// 
				$this->addon_params = $registry;
			}
			// 
			// 
			return $this->addon_params;
		}
		
		
		// Метод получения списка валют робокассы
		// 
		public function getRucodeCurrencies()
		{
			// 
			// 
			$json_file = JPATH_SITE.'/components/com_jshopping/payments/pm_rucode/currencies.json';
			// Если файла нет или он пустой или последний раз он редактировался боле суток назад
			// 
			if (!file_exists($json_file) || (filesize($json_file) < 10) || (time() - filemtime($json_file) > 1 * 60 * 60 * 24))
			{
				// Получаем URL
				// 
				$url = 'https://rucode.io/en/request/payment-methods?merchant_id='.$this->params->get('merchant_id').'&secret_key='.$this->params->get('password_1');
				// 
				// 
				$json_content = $this->curlGetContents($url);
				// 
				// 
				$json = json_decode($json_content, true);
				// Если нет ошибок
				// 
				if ($json->status == 'success')
				{
					// Записываем свежие данные во временный файл с валютами
					// 
					file_put_contents($json_file, $json_content);
				}
			}
			// 
			// 
			$json_content = file_get_contents($json_file);
			// 
			// 
			$json = json_decode($json_content, true);
			// 
			// 
			$groups = array
						(
							'Банковские карты' => array
													(
														'cd' => 'Банковская карта',
														'ap' => 'Apple Pay',
														'gp' => 'Google pay',
														'sp' => 'Samsung Pay'
													),
							'Электронные кошельки' => array
													(
														'qw' => 'Qiwi кошелек',
														'ya' => 'Яндекс Деньги',
														'pa' => 'Payeer',
														'pm' => 'Perfect Money'
													),
							'Криптовалюты' => array
													(
														'bt' => 'Bitcoin'
													),
							'Другие способы' => array
													(
														'sp' => 'Расчетный счет'
													)
						);
			// 
			// 
			$currencies = array();
			// 
			// 
			if (is_array($json['methods']) && count($json['methods']))
			{
				// 
				// 
				foreach ($groups as $group => $currency_codes)
				{
					// 
					$temp_group = new stdclass();
					// 
					$temp_group->title = $group;
					// 
					$temp_group->currencies = array();
					// 
					foreach($currency_codes as $currency_code => $currency_title)
					{
						// 
						// 
						if (isset($json['methods'][$currency_code]))
						{
							// 
							$temp_currency = new stdclass();
							// 
							$temp_currency->title = $currency_title;
							// 
							$temp_currency->code = $currency_code;
							// 
							$temp_group->currencies[] = $temp_currency;
						}
					}
					// 
					// 
					if (count($currency_codes))
					{
						// 
						$currencies[] = $temp_group;
					}
				}
			}
			// 
			// 
			return $currencies;
		}
		
		
		// Метод получения контента с помощью CURL
		private function curlGetContents($url)
		{
			// Инициализируем сеанс cURL
			$ch = curl_init();
			// Устанавливаем опцию не показывать заголовки
			curl_setopt($ch, CURLOPT_HEADER, false);
			// Устанавливаем опцию возврата результата в виде строки
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			// 
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			// 
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
			// Устанавливаем URL
			curl_setopt($ch, CURLOPT_URL, $url);
			// Получаем ответ
			$content = curl_exec($ch);
			// Закрываем соединение
			curl_close($ch);
			// Возвращаем результат
			return $content;
		}
	}