<?php
	// 
	defined('JPATH_PLATFORM') or die;
	
	// 
	// 
	JFormHelper::loadFieldClass('list');
	
	
	// 
	// 
	class JFormFieldRucodeCurrencyGroup extends JFormFieldList
	{
		// 
		// 
		protected $type = 'RucodeCurrencyGroup';
		// 
		// 
		protected $addon;
		
		
		// 
		// 
		public function __construct()
		{
			// 
			// 
			$this->addon = AddonPMRucode::getInstance();
		}
		
		
		// 
		// 
		public function setup(SimpleXMLElement $element, $value, $group = null)
		{
			// 
			// 
			$return = parent::setup($element, $value, $group);
			// 
			// 
			if ($return)
			{
				// 
				// 
				$hideNone = (string)$this->element['hide_none'];
				// 
				// 
				$this->hideNone = ($hideNone == 'true' || $hideNone == 'hideNone' || $hideNone == '1');
				// 
				// 
				$hideDefault = (string)$this->element['hide_default'];
				// 
				// 
				$this->hideDefault = ($hideDefault == 'true' || $hideDefault == 'hideDefault' || $hideDefault == '1');
			}
			// 
			// 
			return $return;
		}
		
		
		// 
		// 
		protected function getOptions()
		{
			// 
			// 
			$options = array();
			// 
			// 
			if (!$this->hideNone)
			{
				// 
				// 
				$options[] = JHtml::_('select.option', '-1', JText::alt('JOPTION_DO_NOT_USE', preg_replace('/[^a-zA-Z0-9_\-]/', '_', $this->fieldname)));
			}
			// 
			// 
			if (!$this->hideDefault)
			{
				// 
				// 
				$options[] = JHtml::_('select.option', '', JText::alt('JOPTION_USE_DEFAULT', preg_replace('/[^a-zA-Z0-9_\-]/', '_', $this->fieldname)));
			}
			// 
			// 
			$rucode_currencies = $this->addon->getRucodeCurrencies();
			// 
			// 
			if (is_array($rucode_currencies))
			{
				// 
				foreach ($rucode_currencies as $rucode_currency)
				{
					// 
					// 
					$options[] = JHtml::_('select.option', $rucode_currency->title, $rucode_currency->title);
				}
			}
			// 
			// 
			$options = array_merge(parent::getOptions(), $options);
			// 
			// 
			return $options;
		}
	}
