<?php
	// 
	defined('JPATH_BASE') or die;
	
	// 
	require_once(JPATH_SITE.'/components/com_jshopping/lib/factory.php');
	// 
	JFormHelper::loadFieldClass('list');	

	class JFormFieldWishBoxJShoppingOrderStatus extends JFormFieldList
	{
		// 
		protected $type = 'WishBoxJShoppingOrderStatus';
		
		// 
		public function setup(SimpleXMLElement $element, $value, $group = null)
		{
			// 
			$return = parent::setup($element, $value, $group);
			// 
			if ($return)
			{
				// 
				$hideNone = (string)$this->element['hide_none'];
				// 
				$this->hideNone = ($hideNone == 'true' || $hideNone == 'hideNone' || $hideNone == '1');
				// 
				$hideDefault = (string)$this->element['hide_default'];
				// 
				$this->hideDefault = ($hideDefault == 'true' || $hideDefault == 'hideDefault' || $hideDefault == '1');
			}
			// 
			return $return;
		}
	
		// 
		protected function getOptions()
		{
			// 
			$options = array();
			// Prepend some default options based on field attributes.
			if (!$this->hideNone)
			{
				// 
				$options[] = JHtml::_('select.option', '-1', JText::alt('JOPTION_DO_NOT_USE', preg_replace('/[^a-zA-Z0-9_\-]/', '_', $this->fieldname)));
			}
			// 
			if (!$this->hideDefault)
			{
				// 
				$options[] = JHtml::_('select.option', '', JText::alt('JOPTION_USE_DEFAULT', preg_replace('/[^a-zA-Z0-9_\-]/', '_', $this->fieldname)));
			}
			
			
			// 
			$db = JFactory::getDbo();
			// 
			$lang = JSFactory::getLang();
			// 
			$query = $db->getQuery(true);
			// 
			$query->select('os.status_id AS id');
			// 
			$query->select('`'.$lang->get('name').'` as name');
			// 
			$query->from('#__jshopping_order_status as os');
			// 
			$db->setQuery($query);
			// 
			$order_statuses = $db->loadObjectList();
			// Build the options list from the list of files.
			if (is_array($order_statuses))
			{
				// 
				foreach ($order_statuses as $order_status)
				{
					// 
					$options[] = JHtml::_('select.option', $order_status->id, $order_status->name);
				}
			}
			// Merge any additional options in the XML definition.
			$options = array_merge(parent::getOptions(), $options);
			// 
			return $options;
		}
	}