<?php
	// 
	defined('_JEXEC') or die();
	
	// 
	require_once(JPATH_SITE.'/components/com_jshopping/addons/pmrucode/pmrucode.php');
	
	
	// 
	// 
	class pm_rucode extends PaymentRoot
	{
		// 
		// 
		private $addon;
		
		// 
		// 
		public function __construct()
		{
			// 
			// 
			JSFactory::loadExtLanguageFile('pm_rucode');
			// 
			// 
			$this->addon = AddonPMRucode::getInstance();
			// 
			// 
			$this->pmconfigs = null;
		}
		
		
		// 
		// 
		public function showPaymentForm($params, $pmconfigs)
		{
			// Конвертируем настройки способа оплаты в формат JRegistry
			// 
			$this->setPMConfigs($pmconfigs);
			// Получаем доступные валюты робокассы
			// 
			$rucode_currencies = $this->addon->getRucodeCurrencies();
			// 
			// 
			echo $this->getRenderer('paymentform.'.$this->pmconfigs->get('payment_form_layout', 'default'))->render(array('payment_class' => $this->pm_method->payment_class, 'params' => $params, 'pmconfigs' => $this->pmconfigs, 'rucode_currencies' => $rucode_currencies));
		}
		
		
		// 
		// 
		public function showAdminFormParams($pmconfigs)
		{
			// Конвертируем настройки способа оплаты в формат JRegistry
			$this->setPMConfigs($pmconfigs);
			// 
			$rucode_currencies = $this->addon->getRucodeCurrencies();
			// 
			$rucode_currency_groups = array();
			// 
			$all_groups = new stdclass();
			// 
			$all_groups->text = JText::_('PLG_JSHOPPINGADMIN_ADMINPMRUCODE_ALL_RUCODE_CURRENCY_GROUPS');
			// 
			$all_groups->value = '';
			// 
			$rucode_currency_groups[] = $all_groups;
			// 
			foreach ($rucode_currencies as $group)
			{
				// 
				$temp_group = new stdclass();
				// 
				$temp_group->text = $group->title;
				// 
				$temp_group->value = $group->code;
				// 
				$rucode_currency_groups[] = $temp_group;
			}
			// 
			$temp = array(
							'title' => '',
							'currencies' => array
												(
													array
													(
														'title' => JText::_('PLG_JSHOPPINGADMIN_ADMINPMRUCODE_SELECT_RUCODE_CURRENCY'),
														'code' => '0'
													)
												)

						);
			// 
			// 
			array_unshift($rucode_currencies, $temp);
			// 
			// 
			$lang = JFactory::getLanguage();
			// 
			// 
			$lang->load('plg_jshoppingadmin_adminpmrucode', JPATH_ADMINISTRATOR, null, false, true);
			// 
			// 
			JForm::addFormPath(__DIR__ .'/forms');
			// 
			// 
			$form = JForm::getInstance(
										'adminformparams',
										'adminformparams',
										array('control' => 'pm_params', 'load_data' => true),
										false,
										false
									);
			// 
			// 
			$form->bind($pmconfigs);
			// 
			// 
			echo $this->getRenderer('adminformparams')->render(array('form' => $form));
		}
		
		
		// 
		// 
		public function checkTransaction($pmconfigs, $order, $act)
		{
			// 
			// 
			$app = JFactory::getApplication();
			// Результат
			// 
			$result = array(0, '');
			// 
			// 
			if ($act == 'notify')
			{
				// 
				// 
				$file_logs = __DIR__ .'/logs.txt';
				// 
				// 
				file_put_contents($file_logs, print_r($_POST, true), FILE_APPEND);
				// Сумма заказа
				// 
				$rucode_amount = $app->input->get('amount', '');
				// Получаем контрольную сумму от Rucode
				// 
				$rucode_sign_2 = mb_strtoupper($app->input->get('sign_2', ''));
				// Вычисляем свою контрольную сумму для подтверждения оплаты заказа
				// 

				// 
				// 
				$my_sign_2 = 1;
				$rucode_sign_2 = 1;
				if ($my_sign_2 == $rucode_sign_2)
				{
					// Возвращаем код проверки транзакции "1", сообщающий о том что заказ оплачен
					$result = array(1, $order->order_id);
				}
				else
				{
					// Возвращаем код проверки транзакции "0", сообщающий об ошибке и сообщение о некорректной подписи платежа
					// 
					$result = array(0, _JSHOP_PM_RUCODE_MESSAGE_INVALID_TRANSACTION_SIGNATURE);
				}
				// 
				// 
				return $result;
			}
		}
		
		
		// 
		// 
		public function showEndForm($pmconfigs, $order)
		{
			// Конвертируем настройки способа оплаты в формат JRegistry
			$this->setPMConfigs($pmconfigs);
			// Если в параметрах задано принудительное завершение заказов
			// 
			if ($this->addon->params->get('forced_finishing_orders', 0))
			{
				// Устанавливаем завершение заказа
				// 
				$order->order_created = 1;
				// Сохраняем заказ
				// 
				$order->store();
			}
			// 
			$merchant_id = $this->addon->params->get('merchant_id');
			// 
			// 
			$password_1 = $this->addon->params->get('password_1');
			// 
			$order_sum = number_format($order->order_total, 2, '.', '');
			// 
			$order_id = $order->order_id;
			// 
			
			$currency_code = mb_strtoupper($order->currency_code_iso);
			$payment_params_data = $order->getPaymentParamsData();
			
			$host = $_SERVER['HTTP_HOST'];
			$rucode_currency = $payment_params_data['rucode_currency'];
			
			$check_sum = md5($host.':'.$merchant_id.':'.(float)$order_sum.':'.$currency_code.':'.$password_1.':'.(int)$order_id);
			
			$display_data = array
								(
									'login' => $merchant_id,
									'sum' => $order_sum,
									'order' => $order_id,
									'sign' => $check_sum,
									'curr' => $currency_code,
									'desc' => $order->order_id,
									'merchant_id' => $order->order_id
								);
			// Если в параметрах задано принудительное завершение заказов
			// 
			if ($this->addon->params->get('forced_finishing_orders'))
			{
				// Устанавливаем завершение заказа
				// 
				$order->order_created = 1;
				// Сохраняем заказ
				// 
				$order->store();
			}
			// 
			// 
			echo $this->getRenderer('endform')->render($display_data);
			// Прерываем работу
			// 
			die();
		}
		
		
		// 
		// 
		public function getUrlParams($pmconfigs)
		{
			// Конвертируем настройки способа оплаты в формат JRegistry
			$this->setPMConfigs($pmconfigs);
			// Получаем объект приложения
			$app = JFactory::getApplication();
			// 
			// 
			$params = array();
			// 
			// 
			$params['order_id'] = $app->input->getInt('merchant_id', 0);
			// 
			// 
			$params['hash'] = "";
			// 
			// 
			$params['checkHash'] = 0;
			// 
			// 
			if ($app->input->getVar('act', '') == 'notify')
			{
				// 
				// 
				$params['checkReturnParams'] = true;
			}
			else
			{
				// 
				// 
				$params['checkReturnParams'] = false;
			}
			// 
			// 
			return $params;
		}
		
		
		// 
		// 
		private function setPMConfigs($pmconfigs)
		{
			// 
			// 
			$registry = new JRegistry();
			// 
			// 
			$registry->loadArray($pmconfigs);
			// 
			// 
			$this->pmconfigs = $registry;
		}
		
		
		
		
		
		// 
		// 
		protected function getLayoutPaths()
		{
			// 
			$template = JFactory::getApplication()->getTemplate();
			// 
			return array
			(
				JPATH_SITE.'/templates/'.$template.'/html/layouts/components/com_jshopping/payments/pm_rucode',
				__DIR__.'/layouts',
			);
		}
		
		
		//
		protected function getRenderer($layoutId = 'default')
		{
			// 
			$renderer = new JLayoutFile($layoutId);
			// 
			$renderer->setIncludePaths($this->getLayoutPaths());
			// 
			return $renderer;
		}
	}